package web.action;

import java.util.ArrayList;
import java.util.List;

import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;

import org.apache.struts.action.Action;
import org.apache.struts.action.ActionForm;
import org.apache.struts.action.ActionForward;
import org.apache.struts.action.ActionMapping;

import persistence.dao.DAOFactory;
import persistence.model.Usuario;
import util.exception.ServiceException;
import util.forward.StrutsForward;
import web.service.NoticiaService;

public class ListaNoticiasAction extends Action {

	private static final long serialVersionUID = 5184319597780160246L;
	private List<String> errors;
	private NoticiaService noticiaService;
    
    public ActionForward execute(ActionMapping mapping, ActionForm form,
    		HttpServletRequest request, HttpServletResponse response)
    throws Exception {
    	String forward = StrutsForward.EXCEPTION;
		Usuario usuario = (Usuario) request.getSession().getAttribute("Usuario");
		errors = new ArrayList<String>();

		try {
			if (usuario != null) {
				noticiaService = DAOFactory.getInstance().getDao(NoticiaService.class);
				String assuntoId = request.getParameter("assuntoId");
				if(assuntoId != null) {
					request.setAttribute("noticias", noticiaService.getAllNoticiasByAssunto(Long.parseLong(assuntoId)));
				}
				else {
					request.setAttribute("noticias", noticiaService.getAllNoticias());
				}

				forward = StrutsForward.SUCCESS;
			}
			else {
				errors.add("Usuário não autenticado");
				request.setAttribute("errors", errors);
				forward = StrutsForward.NO_AUTHENTICATION;
			}
		}	
		catch (Exception e) {
			request.setAttribute("exception", new ServiceException(e));
		}
		
		return mapping.findForward(forward);
	}
}
